      program iasp91
c
c     Making a velovity model for travel time calculation 
c       based on iasp91 model
c	Coded by T. Shibutani
c	Ver. 1996-11-20
c
      implicit real*8 (a-h,o-z)
c      character*80 dummy
      dimension cvp(20,4),cvs(20,4),cdep(20,2)
c
      open(11,file='./iasp91.in',status='old')
      open(21,file='./iasp91.mdl',status='unknown')
c
c---  parameters
c
      a = 6371.0
      dd=1.0
      nl=11
c
c---  read coefficients of iasp91
c
      do il=1,nl
        read(11,*) 
        read(11,*) (cdep(il,i),i=1,2)
	read(11,*) (cvp(il,i),i=1,4)
        read(11,*) (cvs(il,i),i=1,4)
      end do
c
c---  model construction
c
      do 100 il=1,nl
        id=0
  200   continue
        id=id+1
        dep=cdep(il,1)+(id-1)*dd
        if (dep.gt.cdep(il,2)) go to 100
        r=a-dep
        x=r/a
        vp = cvp(il,1) + cvp(il,2)*x + cvp(il,3)* x **2 
     $       + cvp(il,4)* x **3 
        vs = cvs(il,1) + cvs(il,2)*x + cvs(il,3)* x **2 
     $       + cvs(il,4)* x **3 
        xip=r/vp
        if (vs.eq.0.0) then
           xis=0.0
        else
           xis=r/vs
        end if
        write(6,'(6g12.5)') dep,r,vp,vs,xip,xis
        write(21,'(f6.1,2f10.6)') r,vp,vs
        go to 200
  100 continue
c
      stop
      end

