      subroutine tnlyr(p,rt,jt,nu,nd,r,v,eee,nerr)
c
c     Search layer in which the turning radius rt is located.
c       Coded by T. Shibutani
c                1996-11-22
c		 1997-06-15
c
      parameter (ndmax=6400)
c
      implicit real*8 (a-h,o-z)
      dimension r(ndmax),v(ndmax)
c
      nerr=0
c
c --- find turning point downwards
c
      do jd=nu,nd
         xjd=r(jd)/v(jd)
         if (p.ge.xjd) then
            jt=jd
            go to 110
         end if
      end do
c
c --- rays pass through the center of the Earth
c
      jt=nd+1
      rt=r(nd+1)
      return
c
 110  continue
c
c --- turning radius : rt
c
      if (r(jt).eq.r(jt-1)) then
         rt=r(jt)
      else
         b=dlog(v(jt)/v(jt-1))/dlog(r(jt)/r(jt-1))
         a=v(jt)/r(jt)**b
c         write(6,*) 'b,a=',b,a
         if (1-b.le.eee) then
            nerr=1
            return
         else
            rt=(a*p)**(1./(1-b))
         end if
      end if
c
      return
      end
